'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = BabelPluginShortIdentifiers;

var _nameGenerator = require('./nameGenerator');

var _nameGenerator2 = _interopRequireDefault(_nameGenerator);

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function renameIdentifiers(path) {
  const bindings = path.scope.getAllBindings();
  const ownBindings = Object.keys(bindings).filter(b => path.scope.hasOwnBinding(b));
  const names = (0, _nameGenerator2.default)();

  ownBindings.map(b => {
    path.scope.rename(b, names.next().value);
  });
}

function BabelPluginShortIdentifiers() {
  return {
    visitor: {
      Program: renameIdentifiers,
      BlockStatement: renameIdentifiers
    }
  };
}
module.exports = exports['default'];